/*==========================================================================
 *
 *  Copyright (C) 1995 Microsoft Corporation. All Rights Reserved.
 *
 *  File:       dsutil.cpp
 *  Content:    Routines for dealing with sounds from resources
 *
 *
 ***************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif

IDirectSoundBuffer *DSLoadSoundBuffer(IDirectSound *pDS, void *MemAlloc);

BOOL DSReloadSoundBuffer(IDirectSoundBuffer *pDSB, void *MemAlloc);

void *DSGetWaveFile(LPCTSTR lpName,WAVEFORMATEX **ppWaveHeader, BYTE **ppbWaveData, DWORD *pdwWaveSize);

#ifndef _HSNDOBJ_DEFINED
DECLARE_HANDLE32(HSNDOBJ);
#endif

HSNDOBJ SndObjCreate(IDirectSound *pDS, LPCTSTR lpName, int iConcurrent);

void SndObjDestroy(HSNDOBJ hSO);

BOOL SndObjPlay(HSNDOBJ hSO, DWORD dwPlayFlags);

BOOL SndObjStop(HSNDOBJ hSO);

IDirectSoundBuffer *SndObjGetFreeBuffer(HSNDOBJ hSO);

BOOL DSFillSoundBuffer(IDirectSoundBuffer *pDSB, BYTE *pbWaveData, DWORD dwWaveSize);
BOOL DSParseWaveFile(void *pvRes, WAVEFORMATEX **ppWaveHeader, BYTE **ppbWaveData, DWORD *pdwWaveSize);

#ifdef __cplusplus
}
#endif
