#include <dinput.h>

BOOL WINAPI Init_DInput(void);		//Initialisation de DInput
void WINAPI Release_DInput(void);	//Libration de l'objet DInput


/************************************************************************************************/
/*                                                                                              */
/*                                     INIT_DINPUT /0                                           */
/*                                                                                              */
/************************************************************************************************/

BOOL WINAPI Init_DInput(void)
{
	//fonction initialisant les devices utiliss par DInput
    HRESULT hr;

    // cration de l'objet Dinput
    //hr = DirectInputCreate(hInst, DIRECTINPUT_VERSION, IID_IDirectInput, (void**)&g_lpDI, NULL);
	hr = DirectInputCreate(HInst,DIRECTINPUT_VERSION, (IDirectInputA**)&g_lpDI, NULL);
    if (FAILED(hr)) return FALSE;

    // Pointeur sur l'interface Dinput pour le clavier
    hr = g_lpDI->CreateDevice(GUID_SysKeyboard, &lpKeyboard, NULL);
    if (FAILED(hr))
    {
        Release_DInput();
        return FALSE;
    }

	// c_dfDIKeyboard pour indiquer que c'est le clavier
    hr = lpKeyboard->SetDataFormat(&c_dfDIKeyboard);
    if (FAILED(hr))
    {
        Release_DInput();
        return FALSE;
    }

    hr = lpKeyboard->SetCooperativeLevel(hwnd, DISCL_FOREGROUND | DISCL_EXCLUSIVE);
    if (FAILED(hr))
    {
        Release_DInput();
        return FALSE;
    }

    // Aquisition : on peut maintenant lire les touches du clavier
    hr = lpKeyboard->Acquire();
    if (FAILED(hr))
    {
        Release_DInput();
        return FALSE;
    }

    return TRUE;
}


/************************************************************************************************/
/*                                                                                              */
/*                                    RELEASE_DINPUT /0                                         */
/*                                                                                              */
/************************************************************************************************/

void WINAPI Release_DInput(void)
{
	//fonction dtruisant les objets utiliss par DInput
    if (g_lpDI)
    {
        if (lpKeyboard)
        {
			// on nettoie et on libre tout
            lpKeyboard->Unacquire();
            lpKeyboard->Release();
            lpKeyboard = NULL;
        }
        g_lpDI->Release();
        g_lpDI = NULL;
    }
}
